/*--------------------------------------------------------------------------- 
 * Programming the EVM56002DSP in C
 *
 * This example reads toggle switches (PB8-PB11) and displays that on 
 * LED's (PB0-PB3).
 * Author: Johan Forrer, KC7WW
 * Date: January 1997.
 *--------------------------------------------------------------------------*/

#include <stdio.h>

/*--------------------------------------------------------------------------- 
 * Leonid Global Definitions 
 * Note this format for Externals are important!
 *--------------------------------------------------------------------------*/
extern unsigned int Mr __asm("flags_mirror");

/*--------------------------------------------------------------------------- 
 * Globals for this program 
 * PB reflects the status of a Read of PB
 *--------------------------------------------------------------------------*/
unsigned int PB;

void main()
{

	for(;;) {
		Get_PB();						 /* Update PB */
		Set_PB(((PB>>8)&0xF)|Mr);	 /* Toggle switches + bits 13/14	*/
		}

}





/*============HELPER ROUTINES===============================================*/
/*---------------------------------------------------------------------------
 * Routine writes to LED's B0 - B3
 * Note how the argument is taken off the stack,
 * also that all registers are saved. 
 * bits 12/13 is left intact.
 *--------------------------------------------------------------------------*/
Set_PB(unsigned int val)
{
	__asm volatile("	move	n0,Y:(r6)+
							move	#-3,n0\n\
							move 	Y:(r0+n0),a\n\
							move	a1,X:$FFE4\n\
							move	Y:-(r6),n0");
}

/*---------------------------------------------------------------------------
 * Routine reads PB and returns value in global variable PB
 *--------------------------------------------------------------------------*/
Get_PB()
{
	__asm volatile(" 	move	X:$FFE4,a\n\
							move	a1,Y:FPB");
}
